xref: /linux/tools/perf/tests/shell/annotate.sh (revision 7f71507851fc7764b36a3221839607d3a45c2025)
1#!/bin/bash
2# perf annotate basic tests
3# SPDX-License-Identifier: GPL-2.0
4
5set -e
6
7shelldir=$(dirname "$0")
8
9# shellcheck source=lib/perf_has_symbol.sh
10. "${shelldir}"/lib/perf_has_symbol.sh
11
12testsym="noploop"
13
14skip_test_missing_symbol ${testsym}
15
16err=0
17perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
18perfout=$(mktemp /tmp/__perf_test.perf.out.XXXXX)
19testprog="perf test -w noploop"
20# disassembly format: "percent : offset: instruction (operands ...)"
21disasm_regex="[0-9]*\.[0-9]* *: *\w*: *\w*"
22
23cleanup() {
24  rm -rf "${perfdata}" "${perfout}"
25  rm -rf "${perfdata}".old
26
27  trap - EXIT TERM INT
28}
29
30trap_cleanup() {
31  echo "Unexpected signal in ${FUNCNAME[1]}"
32  cleanup
33  exit 1
34}
35trap trap_cleanup EXIT TERM INT
36
37test_basic() {
38  echo "Basic perf annotate test"
39  if ! perf record -o "${perfdata}" ${testprog} 2> /dev/null
40  then
41    echo "Basic annotate [Failed: perf record]"
42    err=1
43    return
44  fi
45
46  # Generate the annotated output file
47  perf annotate --no-demangle -i "${perfdata}" --stdio 2> /dev/null | head -250 > "${perfout}"
48
49  # check if it has the target symbol
50  if ! grep "${testsym}" "${perfout}"
51  then
52    echo "Basic annotate [Failed: missing target symbol]"
53    err=1
54    return
55  fi
56
57  # check if it has the disassembly lines
58  if ! grep "${disasm_regex}" "${perfout}"
59  then
60    echo "Basic annotate [Failed: missing disasm output from default disassembler]"
61    err=1
62    return
63  fi
64
65  # check again with a target symbol name
66  if ! perf annotate --no-demangle -i "${perfdata}" "${testsym}" 2> /dev/null | \
67	  head -250 | grep -m 3 "${disasm_regex}"
68  then
69    echo "Basic annotate [Failed: missing disasm output when specifying the target symbol]"
70    err=1
71    return
72  fi
73
74  # check one more with external objdump tool (forced by --objdump option)
75  if ! perf annotate --no-demangle -i "${perfdata}" --objdump=objdump 2> /dev/null | \
76	  head -250 | grep -m 3 "${disasm_regex}"
77  then
78    echo "Basic annotate [Failed: missing disasm output from non default disassembler (using --objdump)]"
79    err=1
80    return
81  fi
82  echo "Basic annotate test [Success]"
83}
84
85test_basic
86
87cleanup
88exit $err
89